//////////////////////////////////////////////////////////////////////
//
// and.pde
//
// for test NNFpp purposes
//
//
// noonv                                                RoboCraft.ru
//////////////////////////////////////////////////////////////////////

#include "NNFpp.h"

        float weights[]={
            -3.868201,
2.603633, 2.759537 ,
2.221923,
0.242479, 0.843111 ,
-5.077891,
3.518630, 3.420209 ,
2.098542,
1.713860, 1.024128 ,
-3.447142,
5.275442, -2.022131, 7.489859, -1.423821
            };
 
float *out, in[2]={0,0};
int Neurons[3] = {2,4,1};
            
void setup()
{
	Serial.begin(9600);
}

void loop()
{
	Serial.println("Start...");
        Serial.println("Logical AND with neural network");    

        NNFpp net(3,Neurons,1,NNF_SIGMA_LOGISTIC,0.6);
        net.LoadWeights(weights);


        Serial.println("\nTest: ");

                in[0] = 0;
                in[1] = 0;
                out = net.Execute(in);
                Serial.print("0 0 -> 0: ");
				Serial.println(out[0]);

                in[0] = 0;
                in[1] = 1;
                out = net.Execute(in);
                Serial.print("0 1 -> 0: ");
				Serial.println(out[0]);

                in[0] = 1;
                in[1] = 0;
                out = net.Execute(in);
                Serial.print("0 -> 0: ");
				Serial.println(out[0]);

                in[0] = 1;
                in[1] = 1;
                out = net.Execute(in);
                Serial.print("1 1 -> 1: ");
				Serial.println(out[0]);

	//-------------------------
	Serial.println("...end.");
        net.Free();
//	while(1)
//	{}
        delay(1000);
}

