//////////////////////////////////////////////////////////////////////
//
// utils.cpp
//
// certain utilitys
//
//
//    noonv                                                RoboCraft.ru
//////////////////////////////////////////////////////////////////////

#ifndef _UTILS_CPP_
#define _UTILS_CPP_

#include "utils.h"

void prerror(char *ErrorString)
{
	//
	// print error message
	//
#ifndef DUINO
	printf("[!] Error: %s\n",ErrorString);
#else
    Serial.print("[!] Error: ");
    Serial.println(ErrorString);
#endif //#ifndef DUINO
}

void prermem()
{
	prerror("[!] cant allocate memory!");
}

int rnd_init()
{
#ifndef DUINO
	srand(time(NULL));
#else
	randomSeed(analogRead(0));
#endif //#ifndef DUINO
	return 0;
}

int rnd(int number)
{
	//
	// generate random numbers: [0..number)
	//
#ifndef DUINO
	int num;
	num=(int)((double)rand() / ((double)RAND_MAX + 1) * number);
	//## change it for more good !!!!!
	return num;	
#else
	return random(number);
#endif //#ifndef DUINO
}

float frnd(int number)
{
      float num;
#ifndef DUINO
	
# ifdef _WIN32
	num=((float)rand() / ((float)RAND_MAX + 1) * number);
	//## change it for more good !!!!!
	return num;
# else
     num = (float)( ((float)rnd(number)/(float)number)*number );
     return num;
# endif //#ifdef _WIN32

#else
	num = (float)( ((float)rnd(number)/(float)number)*number );
    return num;
#endif //#ifndef DUINO
}

int rnd_end()
{
	return 0;
}

void ZeroMem(char* Destination,size_t Length)
{
     if(!Destination || Length<1)
		return;
	unsigned int i=0;
	for(i;i<Length;i++)
		Destination[i]=0;
}

#endif //#ifndef _UTILS_CPP_
